"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SPScene = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _spBinding = require("./sp-binding");

var _spComponent = require("./sp-component");

var _spComponent2 = _interopRequireDefault(_spComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SPScene = exports.SPScene = function (_Component) {
  _inherits(SPScene, _Component);

  function SPScene() {
    _classCallCheck(this, SPScene);

    return _possibleConstructorReturn(this, (SPScene.__proto__ || Object.getPrototypeOf(SPScene)).apply(this, arguments));
  }

  _createClass(SPScene, [{
    key: "render",
    value: function render() {
      var scene = this.props.scene;

      if (!scene) {
        return _react2.default.createElement("div", null);
      }
      return _react2.default.createElement(
        "div",
        null,
        scene.children.map(function (child) {
          return _react2.default.createElement(_spComponent2.default, _extends({ key: child.id }, child));
        })
      );
    }
  }], [{
    key: "subscribe",
    value: function subscribe(props) {
      return {
        scene: _spBinding.watch.one("scenes", { id: props.sceneId })
      };
    }
  }]);

  return SPScene;
}(_react.Component);

SPScene.propTypes = {
  sceneId: _propTypes2.default.string.isRequired,
  scene: _propTypes2.default.object
};
exports.default = (0, _spBinding.bindComponent)(SPScene);
//# sourceMappingURL=sp-scene.js.map